# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2017_09_01_preview
  module Models
    #
    # Specifies a setup task which can be used to customize the compute nodes
    # of the cluster.
    #
    class SetupTask

      include MsRestAzure

      # @return [String] Command Line to start Setup process.
      attr_accessor :command_line

      # @return [Array<EnvironmentSetting>] Collection of environment settings.
      attr_accessor :environment_variables

      # @return [Boolean] Specifies whether to run the setup task in elevated
      # mode. The default value is false. . Default value: false .
      attr_accessor :run_elevated

      # @return [String] The path where the Batch AI service will upload the
      # stdout and stderror of setup task.
      attr_accessor :std_out_err_path_prefix


      #
      # Mapper for SetupTask class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SetupTask',
          type: {
            name: 'Composite',
            class_name: 'SetupTask',
            model_properties: {
              command_line: {
                client_side_validation: true,
                required: true,
                serialized_name: 'commandLine',
                type: {
                  name: 'String'
                }
              },
              environment_variables: {
                client_side_validation: true,
                required: false,
                serialized_name: 'environmentVariables',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EnvironmentSettingElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EnvironmentSetting'
                      }
                  }
                }
              },
              run_elevated: {
                client_side_validation: true,
                required: false,
                serialized_name: 'runElevated',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              std_out_err_path_prefix: {
                client_side_validation: true,
                required: true,
                serialized_name: 'stdOutErrPathPrefix',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
