# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # Azure Blob Storage Container mounting configuration.
    #
    class AzureBlobFileSystemReference

      include MsRestAzure

      # @return [String] Account name. Name of the Azure storage account.
      attr_accessor :account_name

      # @return [String] Container name. Name of the Azure Blob Storage
      # container to mount on the cluster.
      attr_accessor :container_name

      # @return [AzureStorageCredentialsInfo] Credentials. Information about
      # the Azure storage credentials.
      attr_accessor :credentials

      # @return [String] Relative mount path. The relative path on the compute
      # node where the Azure File container will be mounted. Note that all
      # cluster level containers will be mounted under $AZ_BATCHAI_MOUNT_ROOT
      # location and all job level containers will be mounted under
      # $AZ_BATCHAI_JOB_MOUNT_ROOT.
      attr_accessor :relative_mount_path

      # @return [String] Mount options. Mount options for mounting blobfuse
      # file system.
      attr_accessor :mount_options


      #
      # Mapper for AzureBlobFileSystemReference class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureBlobFileSystemReference',
          type: {
            name: 'Composite',
            class_name: 'AzureBlobFileSystemReference',
            model_properties: {
              account_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'accountName',
                type: {
                  name: 'String'
                }
              },
              container_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'containerName',
                type: {
                  name: 'String'
                }
              },
              credentials: {
                client_side_validation: true,
                required: true,
                serialized_name: 'credentials',
                type: {
                  name: 'Composite',
                  class_name: 'AzureStorageCredentialsInfo'
                }
              },
              relative_mount_path: {
                client_side_validation: true,
                required: true,
                serialized_name: 'relativeMountPath',
                type: {
                  name: 'String'
                }
              },
              mount_options: {
                client_side_validation: true,
                required: false,
                serialized_name: 'mountOptions',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
