# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # Azure File Share mounting configuration.
    #
    class AzureFileShareReference

      include MsRestAzure

      # @return [String] Account name. Name of the Azure storage account.
      attr_accessor :account_name

      # @return [String] Azure File URL. URL to access the Azure File.
      attr_accessor :azure_file_url

      # @return [AzureStorageCredentialsInfo] Credentials. Information about
      # the Azure storage credentials.
      attr_accessor :credentials

      # @return [String] Relative mount path. The relative path on the compute
      # node where the Azure File share will be mounted. Note that all cluster
      # level file shares will be mounted under $AZ_BATCHAI_MOUNT_ROOT location
      # and all job level file shares will be mounted under
      # $AZ_BATCHAI_JOB_MOUNT_ROOT.
      attr_accessor :relative_mount_path

      # @return [String] File mode. File mode for files on the mounted file
      # share. Default value: 0777. Default value: '0777' .
      attr_accessor :file_mode

      # @return [String] Directory mode. File mode for directories on the
      # mounted file share. Default value: 0777. Default value: '0777' .
      attr_accessor :directory_mode


      #
      # Mapper for AzureFileShareReference class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureFileShareReference',
          type: {
            name: 'Composite',
            class_name: 'AzureFileShareReference',
            model_properties: {
              account_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'accountName',
                type: {
                  name: 'String'
                }
              },
              azure_file_url: {
                client_side_validation: true,
                required: true,
                serialized_name: 'azureFileUrl',
                type: {
                  name: 'String'
                }
              },
              credentials: {
                client_side_validation: true,
                required: true,
                serialized_name: 'credentials',
                type: {
                  name: 'Composite',
                  class_name: 'AzureStorageCredentialsInfo'
                }
              },
              relative_mount_path: {
                client_side_validation: true,
                required: true,
                serialized_name: 'relativeMountPath',
                type: {
                  name: 'String'
                }
              },
              file_mode: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fileMode',
                default_value: '0777',
                type: {
                  name: 'String'
                }
              },
              directory_mode: {
                client_side_validation: true,
                required: false,
                serialized_name: 'directoryMode',
                default_value: '0777',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
